class Mapa::Utility

  def initialize(args)
    action = args[0].to_sym
    option = args[1]
    options = args[1..-1]
    if self.respond_to? action
      case self.method(action).arity
      when 1
        self.send(action, option)
      when -1
        self.send(action, options)
      else
        self.send(action)
      end
    else
      if not(options.empty?)
        e "git #{action.to_s} #{options}"
      else
        e "git #{action.to_s}"
      end
    end
  end

  def in
    e 'git init'
  end

  def go(message)
    e "git add . && git commit -m '#{message}' && git branch | xargs git push origin"
  end

  def rh
    e 'git reset --hard'
  end

  def ad
    e 'git add .'
  end

  def st
    e 'git status'
  end

  def cm(message)
    e "git commit -m '#{message}'"
  end

  def br(*options)
    case (patterns = options.flatten).first
    when '-a'
      e 'git branch'
    when '-d'
      patterns[1..-1].each do |branch|
        e "git branch | grep '#{branch}' | xargs git branch -D"
      end
    else
      e 'git rev-parse --abbrev-ref HEAD'
    end
  end

  def df
    e 'git diff'
  end

  def fo
    e 'git fetch origin'
  end

  def pl
    e 'git rev-parse --abbrev-ref HEAD | xargs git pull origin'
  end

  def ph
    e 'git rev-parse --abbrev-ref HEAD | xargs git push origin'
  end

  def co(*options)
    case (options = options.flatten).first
    when '-b'
      e "git checkout -b #{options[1]}"
    else
      e "git checkout '#{options[1]}' && git rev-parse --abbrev-ref HEAD"
    end
  end

  private
  def e(action)
    exec action
  end
end